/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
// ̃Tv́A}ʏɔzuꂽ}iȂl擾\}̂łB
//
// sɂ́A炩߃Tv}"ListUpAttribute.rpcd"JĂB
// ܂́AL̏𖞂}ʂJĂB
// "PRICE"ƂȎli𕶎ɂ́j}i"FLOOR"ƂO̕}ɂ邱ƁB
// śuRootPro CADv[AhC]j[[\̍쐬]Iт܂B
// Copyright @ TECHNICAL STAFF Corporation 2010
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

using System;
using System.Windows.Forms;
using System.Collections.Generic;
using RootPro.RootProCAD;
using RootPro.RootProCAD.Command;
using RootPro.RootProCAD.Geometry;

namespace RCAddInAttributeListCS
{
    public partial class RootProCADApplication
    {
        String commandName = "\̍쐬";// R}h
        String commandResistName = "DrawListCS";// R}h}l[W[o^pR}h

        /// <summary>
        /// AhCN̏
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void RootProCADApplication_Startup(object sender, EventArgs e)
        {
            // j[ɃR}hǉ
            MacroCommandCallback mc = MacroCommand;// ǉR}h֐
            CommandManager.AddMacroCommand(commandName, mc);

            // R}h}l[W[ɃR}hǉ // (R}hEBhEő삷R}hɂȂ܂)
            Command command = CommandManager.AddCommand(commandResistName);@// R}h}l[W[o^pR}h
            command.Name = commandName;// R}hisɃR}hEBhEɕ\܂j
            // Wp[^̒ǉ
            CommandParameterGroupCollection parameterGroups = command.ParameterGroups;
            CommandParameterGroup parameterGroup = parameterGroups.Add(ParameterItemType.Point, 0, "zu_W()");

            // p[^̕ύXCxgo^
            command.ParameterChanged += new CommandParameterChangedEventHandler(command_ParameterChanged); // Cxg֐:command_ParameterChanged 
        }

        /// <summary>
        /// AhC̏Ȉ
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void RootProCADApplication_Shutdown(object sender, EventArgs e)
        {
            // R}h̍폜(IɕKs)
            CommandManager.RemoveMacroCommand(MacroCommand); // ǉR}h֐

            // R}h}l[W[ɓo^R}hɍ폜(IɕKs)
            CommandManager.RemoveCommand(commandResistName); // ǉR}h
        }

        #region VSTA generated code
        private void InternalStartup()
        {
            this.Startup += new System.EventHandler(RootProCADApplication_Startup);
            this.Shutdown += new System.EventHandler(RootProCADApplication_Shutdown);
        }
        #endregion

 
        /// <summary>
        /// j["\̍쐬"R}hsƂ̏
        /// </summary>
        private void MacroCommand()
        {
            // R}hs(R}h}l[W[o^pR}hg)
            CommandManager.ExecuteCommand(commandResistName);
        }

        /// <summary>
        /// p[^ύXCxg //izu_W͂ꂽƂj
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void command_ParameterChanged(Object sender, CommandParameterChangedEventArgs e)
        {
            Command command = (Command)sender;
            int id = e.ParameterID;// ύX̂p[^ID
            ParameterItem parameterItem = command.GetParameterItemByID(id); // p[^ACe

            // p[^ACeW^Cv̏ꍇ
            if (parameterItem.ParameterType == ParameterItemType.Point)
            {
                PointParameterItem pointParameterItem = (PointParameterItem)parameterItem;
                Point2d point = pointParameterItem.Point; // zu_W̎擾

                // \̍쐬s
                DrawPriceList(point);
            }

            e.CommandState = CommandState.End; // I
        }


        /// <summary>
        /// }ȋgāAWv\쐬܂B
        /// </summary>
        /// <param name="point">\̔zu_()</param>
        private void DrawPriceList(Point2d point)
        {
            Document doc = ActiveDocument;// ANeBuȐ}ʂ̎擾
            DrawingCollection drawings = doc.Drawings;// }RNV擾
            Drawing drawing = drawings["FLOOR"];// "FLOOR"}̐}`Ώۂɂ

            // FLOOR ȂΏI
            if (drawing == null)
            {
                MessageBox.Show("}uFROORv܂BTvp̐}ʃt@CJĂB");
                return;
            }

            // J[\v
            Cursor.Current = Cursors.WaitCursor;

            // WvpnbVe[u(L[͍}i, lint(,lPRICE̍v)̔z)p
            Dictionary<string, int[]> priceDict = new Dictionary<string, int[]>(); // Dictionary(System.Collections.GenericOԁj

            ///// }̑S}`}i /////
            Shape shape = null;
            shape = drawing.Shapes.GetNextShape(shape);// }ɂŏ̐}`
            while (shape != null)
            {
                // }ȉꍇ
                if (shape is DrawComponentShape)
                {
                    DrawComponentShape drawComponentShape = (DrawComponentShape)shape;

                    // }i`擾
                    MasterDrawComponent masterDrawComponent = drawComponentShape.Master;

                    // }i`̖O擾
                    String drawComponentName = masterDrawComponent.Name;

                    //  PRICE ꍇ̃CfbNX擾
                    ShapeAttributeCollection shapeAttributes = drawComponentShape.Attributes;
                    int index = shapeAttributes.IndexOfName("PRICE");
                    if (index >= 0)
                    {
                        // zuĂ}iPRICEl擾
                        ShapeAttribute shapeAttribute = shapeAttributes[index];// }i`̑ƓPRICẼCfbNXPRICEl擾
                        String priceText = shapeAttribute.Value;// zij
                        int price = int.Parse(priceText);       // z𐔒lɕϊ

                        int[] itemInfo;
                        // WvpnbVe[uɍ}i`̖OL[ɂ݂̂ȏꍇ
                        if (!priceDict.TryGetValue(drawComponentName, out itemInfo))
                        {
                            itemInfo = new int[2];
                            itemInfo[0] = 1;        // 
                            itemInfo[1] = price;    // z

                            // }i̖OL[ɐVl̒ǉ
                            priceDict.Add(drawComponentName, itemInfo);
                        }
                        // ݂ꍇ͍XV
                        else
                        {
                            itemInfo[0] = itemInfo[0] + 1;        // 
                            itemInfo[1] = itemInfo[1] + price;    // z

                            priceDict[drawComponentName] = itemInfo;
                        }
                    }
                }

                shape = drawing.Shapes.GetNextShape(shape);// ̐}`
            }

            // }iȂꍇ͏I
            if (priceDict.Count == 0)
            {
                MessageBox.Show("ɁuPRICEvݒ肳ꂽ}izuĂ܂B");
                return;
            }

            // \̐ƕ}
            DrawListLineText(point, priceDict);
        }


        /// <summary>
        /// \̐ƕ}
        /// </summary>
        /// <param name="locatePoint">\̔zu_()</param>
        /// <param name="priceDict">WvpnbVe[u</param>
        private void DrawListLineText(Point2d locatePoint, Dictionary<string, int[]> priceDict)
        {
            Document doc = ActiveDocument;          // ANeBuȐ}
            Drawing drawing = doc.CurrentDrawing;   // Jg}

            // ̊l擾
            TextSettings textSettings = doc.TextSettings;

            // \̍s(ږ{}i̎ނ̐{vj
            int rowCount = 1 + priceDict.Count + 1;

            // \̗̐
            const int columnCount = 3;

            // ̍
            double textHeight = textSettings.FontHeight;

            // 
            double[] columnWidth = new double[columnCount];
            // }iiږFij̕
            columnWidth[0] = 8 * textHeight; // 1̕ƓƂ8񕝂ɂ

            // ̕
            columnWidth[1] = 3 * textHeight;

            // z̕
            columnWidth[2] = 5 * textHeight;

            // \Ŝ̕
            double listTotalWidth = 0.0;
            for (int i = 0; i < columnCount; i++)
            {
                listTotalWidth += columnWidth[i];
            }

            // Z̃ItZbgl
            double offset = textHeight * 0.2; // 1Zɏ̗]

            // Z̍
            double cellHight = textHeight + offset * 2;

            // \Ŝ̍
            double listTotalHeight = cellHight * rowCount;

            // UNDO \ȑJn
            doc.UndoManager.BeginUndoUnit();

            ///// `(\̔zu_͍) /////
            // 
            for (int i = 0; i <= rowCount; i++)
            {
                // 
                Point2d point1 = Geometry.CreatePoint(locatePoint.X, locatePoint.Y - cellHight * i); // n_
                Point2d point2 = Geometry.CreatePoint(locatePoint.X + listTotalWidth, locatePoint.Y - cellHight * i); // I_
                LineShape line = drawing.Shapes.AddLine(point1, point2); // ̒ǉ
                line.Linetype = doc.Linetypes.GetLinetypeByNumber(1);// ()
            }

            // c
            double lastPointX = 0.0;
            for (int i = 0; i <= columnCount; i++)
            {
                // 
                double x = 0.0;
                if (i == 0)
                    x = locatePoint.X;
                else
                    x = lastPointX + columnWidth[i - 1];

                Point2d point1 = Geometry.CreatePoint(x, locatePoint.Y); // n_
                Point2d point2 = Geometry.CreatePoint(x, locatePoint.Y - listTotalHeight); // I_
                LineShape line = drawing.Shapes.AddLine(point1, point2); // ̒ǉ
                line.Linetype = doc.Linetypes.GetLinetypeByNumber(1);// ()

                lastPointX = x;
            }


            ///// Zɕ /////
            String[] cellText = new String[3];
            double[] textLocatePointX = new double[3];// zu_XW1ځA2ځA3ځi1ڂ͍A2A3ڂ͉Ej
            textLocatePointX[0] = locatePoint.X + offset;
            textLocatePointX[1] = locatePoint.X + columnWidth[0] + columnWidth[1] - offset;
            textLocatePointX[2] = locatePoint.X + columnWidth[0] + columnWidth[1] + columnWidth[2] - offset;

            // ږs
            cellText[0] = "i"; // 1ځiij
            cellText[1] = "";   // 2ځij
            cellText[2] = "z"; // 3ځizj

            // zu_YW
            double textLocatePointY = locatePoint.Y - cellHight + offset;
            // o
            DrawPriceText(doc, drawing, cellText, textLocatePointX, textLocatePointY);

            // iAAzivj̒l
            int totalPartsCount = 0;
            int totalPrice = 0;
            foreach (String key in priceDict.Keys)
            {
                int[] itemInfo = priceDict[key];

                int partsCount = itemInfo[0]; // i̐
                int price = itemInfo[1];      // i̋zivj

                // vlXV
                totalPartsCount += partsCount;
                totalPrice += price;

                // 
                cellText[0] = key;// 1ځiij
                cellText[1] = partsCount.ToString();// 2ځij
                cellText[2] = price.ToString();// 3ځizj

                // YW
                textLocatePointY -= cellHight;

                // o
                DrawPriceText(doc, drawing, cellText, textLocatePointX, textLocatePointY);

            }

            // vs
            // 
            cellText[0] = "v";// 1ځiij
            cellText[1] = totalPartsCount.ToString();// 2ځij
            cellText[2] = totalPrice.ToString();// 3ځizj

            // YW
            textLocatePointY -= cellHight;

            // o
            DrawPriceText(doc, drawing, cellText, textLocatePointX, textLocatePointY);

            // UNDO \ȑI
            doc.UndoManager.EndUndoUnit();
        }


        /// <summary>
        /// \̕1s
        /// </summary>
        /// <param name="doc"></param>
        /// <param name="drawing"></param>
        /// <param name="textLine">̔z(3)</param>
        /// <param name="textLocatePointX">zu_XW</param>
        /// <param name="textLocatePointY">zu_YW</param>
        private void DrawPriceText(Document doc, Drawing drawing, String[] textLine, double[] textLocatePointX, double textLocatePointY)
        {
            TextShape textShape;
            Point2d textLocatePoint = Geometry.CreatePoint(0.0, textLocatePointY);

            // 1
            textLocatePoint.X = textLocatePointX[0];
            textShape = drawing.Shapes.AddText(textLine[0], textLocatePoint, 0);
            textShape.Color = doc.Colors.GetColorByNumber(1);// F()
            textShape.Alignment = Alignment.BottomLeft;      // 

            // 2
            textLocatePoint.X = textLocatePointX[1];
            textShape = drawing.Shapes.AddText(textLine[1], textLocatePoint, 0);
            textShape.Color = doc.Colors.GetColorByNumber(1);// F()
            textShape.Alignment = Alignment.BottomRight;     // E

            // 3
            textLocatePoint.X = textLocatePointX[2];
            textShape = drawing.Shapes.AddText(textLine[2], textLocatePoint, 0);
            textShape.Color = doc.Colors.GetColorByNumber(1);// F()
            textShape.Alignment = Alignment.BottomRight;     // E
        }

    }
}
